%%  lsg_sys_kalman_ini.m
%%  Kap 11.7.3
%%  Initialisierungsdatei zu lsg_sys_kalman.mdl

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Es handelt sich hier nicht um ein technisches System, sondern um 
% ein fiktives System, an dem der Regelungsentwurf in Matlab und die
% Simulation in Simulink eingebt werden soll
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Tstop = 10;
max_step = 0.01;

% Regelstrecke
z = [1 1];                    % zeros
p = [-2 -3+10*i -3-10*i];     % poles
g = 2;                        % gain

% Rckfhrung des Systems (dies ist noch kein Regler !!!)
num = 2;
den = [0.02 1];

% Verstrkung
verst = 100;

% Rauschen
Q = 1e-3;     % Varianz des Prozerauschens
R = 1e-3;     % Varianz des Merauschens

% Kalmanfilterentwurf

[A,B,C,D] = linmod('system_bsp');        % Systemmatrizen extrahieren
sys_strecke = ss(A,B,C,D);               % ss-Objekt erstellen
sys = ss(A,[B B],C,D);                   % ss-Objekt mit Rausch-Bercksichtigung
[kest, L, P] = kalman(sys,Q,R);          % Kalman-Filter entwerfen

% Simulation starten

sim('lsg_sys_kalman')

% Ergebnis graphisch darstellen

figure
subplot(2,2,1)
plot(t,y,t,ye,t,yw);axis([0 10 -15 15]);legend('gemessen','geschtzt','exakt')
xlabel('Zeit [s]');title('Schtzung der Ausgangsgre')
subplot(2,2,2)
plot(t,xe);axis([0 10 -10 60]);
xlabel('Zeit [s]');title('Schtzung der Zustandsgren')
% print -depsc ausg_kalman.eps
